diff --git a/src/backend/utils/activity/wait_event_timing.c b/src/backend/utils/activity/wait_event_timing.c
index 0fd5092b268..1cfdb112411 100644
--- a/src/backend/utils/activity/wait_event_timing.c
+++ b/src/backend/utils/activity/wait_event_timing.c
@@ -15,11 +15,16 @@
  * attach on their first wait event under capture; a before_shmem_exit gate
  * keeps the hot path away from DSA mappings that proc_exit has torn down.
  *
- * Controlled by the wait_event_capture GUC (off | stats, default off) and
- * the compile-time option --enable-wait-event-timing.  In builds without
- * that option the file still compiles (the GUC backing variable, the enum
- * table, the rejecting check hook, and empty-result SQL stubs), so the GUC
- * and the catalog functions exist uniformly.
+ * At the trace level, every completed wait (and a set of query-attribution
+ * markers) is additionally pushed into a per-session DSA ring buffer that
+ * survives backend exit for post-mortem reading; see the trace section
+ * below and the lifecycle discussion on WaitEventTraceControl.
+ *
+ * Controlled by the wait_event_capture GUC (off | stats | trace, default
+ * off) and the compile-time option --enable-wait-event-timing.  In builds
+ * without that option the file still compiles (the GUC backing variables,
+ * the enum table, the rejecting check hook, and empty-result SQL stubs),
+ * so the GUC and the catalog functions exist uniformly.
  *
  * Copyright (c) 2026, PostgreSQL Global Development Group
  *
@@ -41,17 +46,46 @@
  */
 int			wait_event_capture = WAIT_EVENT_CAPTURE_OFF;
 int			wait_event_timing_max_tranches = 192;
+int			wait_event_trace_ring_size = 4096;
+
+/*
+ * Records-per-ring derived from wait_event_trace_ring_size at server
+ * start.  Read by the writer (via the per-ring cached mask) and by the ring
+ * allocator.  Zero until the GUC framework commits the boot value.
+ */
+uint32		WaitEventTraceRingSize = 0;
 
 /*
  * Enum value table consumed by guc.c.  Order matches the
- * WaitEventCaptureLevel enum and the documented "off < stats" ordering.
+ * WaitEventCaptureLevel enum and the documented "off < stats < trace".
  */
 const struct config_enum_entry wait_event_capture_options[] = {
 	{"off", WAIT_EVENT_CAPTURE_OFF, false},
 	{"stats", WAIT_EVENT_CAPTURE_STATS, false},
+	{"trace", WAIT_EVENT_CAPTURE_TRACE, false},
 	{NULL, 0, false}
 };
 
+/*
+ * GUC check hook for wait_event_trace_ring_size.  The ring size in records
+ * must be a power of two for the writer's mask-indexing (pos & ring_mask).
+ * Each record is 32 bytes, so kb is a power of two iff the record count is.
+ * Defined for both build configurations so the GUC framework validates it
+ * uniformly.
+ */
+bool
+check_wait_event_trace_ring_size(int *newval, void **extra, GucSource source)
+{
+	int			v = *newval;
+
+	if (v <= 0 || (v & (v - 1)) != 0)
+	{
+		GUC_check_errdetail("wait_event_trace_ring_size must be a positive power of two.");
+		return false;
+	}
+	return true;
+}
+
 #ifndef USE_WAIT_EVENT_TIMING
 
 /*
@@ -65,6 +99,9 @@ Datum		pg_stat_get_wait_event_timing(PG_FUNCTION_ARGS);
 Datum		pg_stat_get_wait_event_timing_overflow(PG_FUNCTION_ARGS);
 Datum		pg_stat_reset_wait_event_timing(PG_FUNCTION_ARGS);
 Datum		pg_stat_reset_wait_event_timing_all(PG_FUNCTION_ARGS);
+Datum		pg_get_backend_wait_event_trace(PG_FUNCTION_ARGS);
+Datum		pg_get_wait_event_trace(PG_FUNCTION_ARGS);
+Datum		pg_stat_clear_orphaned_wait_event_rings(PG_FUNCTION_ARGS);
 
 Datum
 pg_stat_get_wait_event_timing(PG_FUNCTION_ARGS)
@@ -80,6 +117,27 @@ pg_stat_get_wait_event_timing_overflow(PG_FUNCTION_ARGS)
 	PG_RETURN_VOID();
 }
 
+Datum
+pg_get_backend_wait_event_trace(PG_FUNCTION_ARGS)
+{
+	InitMaterializedSRF(fcinfo, 0);
+	PG_RETURN_VOID();
+}
+
+Datum
+pg_get_wait_event_trace(PG_FUNCTION_ARGS)
+{
+	InitMaterializedSRF(fcinfo, 0);
+	PG_RETURN_VOID();
+}
+
+Datum
+pg_stat_clear_orphaned_wait_event_rings(PG_FUNCTION_ARGS)
+{
+	/* No trace infrastructure in this build, so never any orphans. */
+	PG_RETURN_INT64(0);
+}
+
 Datum
 pg_stat_reset_wait_event_timing(PG_FUNCTION_ARGS)
 {
@@ -135,9 +193,11 @@ assign_wait_event_capture(int newval, void *extra)
 
 /* No shared memory is reserved in the stub build. */
 const ShmemCallbacks WaitEventTimingShmemCallbacks = {0};
+const ShmemCallbacks WaitEventTraceControlShmemCallbacks = {0};
 
 /* Defined so every extern in wait_event_timing.h resolves in stub builds. */
 WaitEventTimingState *my_wait_event_timing = NULL;
+int			my_trace_proc_number = -1;
 
 void
 pgstat_set_wait_event_timing_storage(int procNumber)
@@ -149,6 +209,35 @@ pgstat_reset_wait_event_timing_storage(void)
 {
 }
 
+void
+wait_event_trace_attach(int procNumber)
+{
+}
+
+/*
+ * Stub trace-marker entry points -- declared unconditionally in the header
+ * so call sites in execMain.c/postgres.c/backend_status.c need no #ifdef.
+ */
+void
+wait_event_trace_query_start(int64 query_id)
+{
+}
+
+void
+wait_event_trace_query_end(int64 query_id)
+{
+}
+
+void
+wait_event_trace_exec_start(int64 query_id)
+{
+}
+
+void
+wait_event_trace_exec_end(int64 query_id)
+{
+}
+
 #else							/* USE_WAIT_EVENT_TIMING */
 
 #include "catalog/pg_authid.h"
@@ -167,6 +256,7 @@ pgstat_reset_wait_event_timing_storage(void)
 #include "utils/backend_status.h"
 #include "utils/builtins.h"
 #include "utils/dsa.h"
+#include "utils/injection_point.h"
 #include "utils/tuplestore.h"
 #include "utils/wait_event.h"
 
@@ -233,6 +323,107 @@ static Size wait_event_timing_per_backend_stride = 0;
 static int	wait_event_timing_hash_size = 0;
 static int	wait_event_timing_max_entries = 0;
 
+/* ---- Trace-level (wait_event_capture = trace) state ---- */
+/* Pointer to this backend's trace ring buffer */
+static WaitEventTraceState *my_wait_event_trace = NULL;
+
+/* DSA-based trace ring buffer control */
+static WaitEventTraceControl *WaitEventTraceCtl = NULL;
+static dsa_area *trace_dsa = NULL;
+int			my_trace_proc_number = -1;
+
+/*
+ * Same-backend coordination between pg_get_backend_wait_event_trace (the
+ * own-session SRF reader) and wait_event_trace_release_slot (the GUC
+ * step-down path that frees this backend's ring).  Both paths run in this
+ * same backend, single-threaded, so a plain bool is sufficient -- no
+ * atomics needed.
+ *
+ *   srf_in_progress   set true while the SRF is iterating the ring; the
+ *                     release path observes this and defers the dsa_free
+ *                     instead of yanking the chunk out from under us.
+ *
+ *   release_pending   set by the release path when it had to defer; the
+ *                     SRF's PG_FINALLY checks it and performs the deferred
+ *                     dsa_free after the iteration completes.
+ *
+ * Cross-backend readers (extensions, bgworkers reading another backend's
+ * ring) cannot use this mechanism -- they coordinate with the release
+ * path via WaitEventTraceCtl->lock instead.  See the header for the
+ * recommended snapshot-under-lock pattern for those consumers.
+ */
+static bool wait_event_trace_srf_in_progress = false;
+static bool wait_event_trace_release_pending = false;
+
+/*
+ * Per-backend gate that disables the trace-ring writer in the wait-
+ * event hot path while a slot-state transition is in progress.
+ *
+ * Set true around code paths that either free the local trace ring
+ * (wait_event_trace_release_slot's dsa_free) or transition the slot
+ * out of OWNED (wait_event_trace_before_shmem_exit's OWNED ->
+ * ORPHANED publish).  In both cases an internal LWLock inside
+ * dsa_free / dsa_attach / dsa_pin_mapping / dsa_pin can in
+ * principle contend long enough to dispatch a wait event; that
+ * wait event's pgstat_report_wait_end_timing inline path runs in
+ * the SAME backend, sees capture_level == TRACE (the GUC hasn't
+ * been committed yet by the time the assign hook runs), and would:
+ *
+ *   * during release_slot's dsa_free: write into a ring that has
+ *     already been returned to the DSA freelist -- if another
+ *     allocator has since reused the chunk, this is a stray write
+ *     into someone else's allocation.
+ *
+ *   * during release_slot's dsa_free, alternative timing: see
+ *     my_wait_event_trace == NULL on a naive "clear before free"
+ *     fix and recurse into wait_event_trace_attach, which would
+ *     either deadlock on the WaitEventTraceCtl->lock the outer
+ *     release_slot already holds, or (on a lock-free moment)
+ *     allocate a fresh ring that the outer release_slot would
+ *     then free again as part of its post-acquire DsaPointerIsValid
+ *     check -- a different use-after-free of a freshly-allocated
+ *     chunk.
+ *
+ *   * during before_shmem_exit: write into the ring after the slot
+ *     has been published as ORPHANED, violating the post-mortem
+ *     read-only contract that cross-backend readers rely on.
+ *
+ * The flag is per-backend (static at file scope means per-process
+ * in PG's process-per-backend model), so the hot path's check is a
+ * single cache-warm load and a branch; no atomic, no fence.  The
+ * trace branch is already gated by capture_level == TRACE so the
+ * additional check costs nothing in the common case where capture
+ * is off or stats-only.  The flag is set on the very same backend
+ * that may later read it from the hot path, so there is no
+ * cross-process visibility concern.
+ *
+ * See the release_slot and before_shmem_exit doc comments for the
+ * specific transition each uses this flag around.
+ */
+static bool wait_event_trace_writes_disabled = false;
+
+/*
+ * Re-entrancy guard for the trace-record writer in
+ * pgstat_report_wait_end_timing(): wait events emitted while a trace
+ * record is mid-write are not themselves ring-recorded.  In production the
+ * record write is a handful of plain stores and cannot wait, so this never
+ * fires; it exists for the injection point inside the writer, whose wait
+ * machinery emits nested wait events that would otherwise recurse into the
+ * writer (and, by re-running the injection point, self-deadlock on locks
+ * the outer invocation holds).  Per-backend, single-threaded -- a plain
+ * bool suffices.
+ */
+static bool wait_event_trace_in_write = false;
+
+/*
+ * Forward declarations for trace functions referenced before their
+ * definitions (the storage/assign hooks call them; the bodies are in the
+ * trace machinery section below).
+ */
+static void wait_event_trace_detach(int procNumber);
+static void wait_event_trace_release_slot(int procNumber);
+static void wait_event_trace_clear_orphan_at_init(int procNumber);
+
 /*
  * Mapping arrays for the flat events[] array, generated from
  * wait_event_names.txt by generate-wait_event_types.pl.  Defines
@@ -748,17 +939,39 @@ void
 pgstat_set_wait_event_timing_storage(int procNumber)
 {
 	my_wait_event_timing = NULL;
+	my_wait_event_trace = NULL;
+
+	if (procNumber < 0 || procNumber >= NUM_WAIT_EVENT_TIMING_SLOTS)
+	{
+		my_trace_proc_number = -1;
+		return;
+	}
+
+	my_trace_proc_number = procNumber;
+
+	/*
+	 * If the previous occupant of this procNumber left an ORPHANED trace ring
+	 * behind (we do not free trace rings at backend exit -- see
+	 * WaitEventTraceControl), free it now so this backend starts with a clean
+	 * FREE slot.
+	 */
+	wait_event_trace_clear_orphan_at_init(procNumber);
 }
 
 /*
- * Detach from the timing slot on backend exit.  The slot stays in DSA;
- * clearing the local pointer keeps the late-shutdown hot path from touching
+ * Detach from the timing slot on backend exit.  The slots stay in DSA;
+ * clearing the local pointers keeps the late-shutdown hot path from touching
  * already-detached memory.
  */
 void
 pgstat_reset_wait_event_timing_storage(void)
 {
+	if (my_trace_proc_number >= 0)
+		wait_event_trace_detach(my_trace_proc_number);
+
 	my_wait_event_timing = NULL;
+	my_wait_event_trace = NULL;
+	my_trace_proc_number = -1;
 }
 
 /*
